代码随想录day07 哈希表part02 LeetCode454.四数相加II 383. 赎金信 15. 三数之和 18. 四数之和

第454题.四数相加II

力扣题目链接(opens new window)

给定四个包含整数的数组列表 A , B , C , D ,计算有多少个元组 (i, j, k, l) ,使得 A[i] + B[j] + C[k] + D[l] = 0。

为了使问题简单化,所有的 A, B, C, D 具有相同的长度 N,且 0 ≤ N ≤ 500 。所有整数的范围在 -2^28 到 2^28 - 1 之间,最终结果不会超过 2^31 - 1 。

例如:

输入:

  • A = [ 1, 2]
  • B = [-2,-1]
  • C = [-1, 2]
  • D = [ 0, 2]

输出:

2

解释:

两个元组如下:

  1. (0, 0, 0, 1) -> A[0] + B[0] + C[0] + D[1] = 1 + (-2) + (-1) + 2 = 0
  2. (1, 1, 0, 0) -> A[1] + B[1] + C[0] + D[0] = 2 + (-1) + (-1) + 0 = 0

初版解法

3个for循环套for循环完成,3*n^2完成,还有优化空间,思路为:先求出a,b数组的和以及出现次数,存入dict1,同理求出c,d数组的情况,存入dict2,再做一次for套for循环,找出和为0的组合,计数方面直接加上,dict1内对应元素出现次数*dict2内对应元素出现次数,一遍直接过,但是时间和空间方面的表现都相当难看。

class Solution:
    def fourSumCount(self, nums1: List[int], nums2: List[int], nums3: List[int], nums4: List[int]) -> int:
        dict1 = dict()
        dict2 = dict()
        countt = 0
        for a in nums1:
            for b in nums2:
                key = a + b
                if key in dict1:
                    dict1[key] += 1
                else:
                    dict1[key] = 1

        for c in nums3:
            for d in nums4:
                key = c + d
                if key in dict2:
                    dict2[key] += 1
                else:
                    dict2[key] = 1

        for key1 in dict1.keys():
            for key2 in dict2.keys():
                if key1 + key2 == 0:
                    countt += dict1[key1] * dict2[key2]
        
        return countt

写到最后才意识到dict2的存在完全多余,因为满足要求时,dict1[key1] = -dict2[key2],可以通过这层关系删去dict2,结果如下:

class Solution:
    def fourSumCount(self, nums1: List[int], nums2: List[int], nums3: List[int], nums4: List[int]) -> int:
        dict1 = dict()
        countt = 0
        for a in nums1:
            for b in nums2:
                key = a + b
                if key in dict1:
                    dict1[key] += 1
                else:
                    dict1[key] = 1

        for c in nums3:
            for d in nums4:
                key = c + d
                if key * -1 in dict1:
                    countt += dict1[key * -1]

        return countt

时间表现上好很多,快了2倍。

383. 赎金信

力扣题目链接(opens new window)

给定一个赎金信 (ransom) 字符串和一个杂志(magazine)字符串,判断第一个字符串 ransom 能不能由第二个字符串 magazines 里面的字符构成。如果可以构成,返回 true ;否则返回 false。

(题目说明:为了不暴露赎金信字迹,要从杂志上搜索各个需要的字母,组成单词来表达意思。杂志字符串中的每个字符只能在赎金信字符串中使用一次。)

注意:

你可以假设两个字符串均只含有小写字母。

canConstruct("a", "b") -> false
canConstruct("aa", "ab") -> false
canConstruct("aa", "aab") -> true

字母种类数固定,构建一个26元素的列表作为哈希表即可,每个元素代表杂志中剩余可用的字母数,本题与242.有效的字母异位词思路完全一致,不多做解释,具体内容可参见前一期内容。

class Solution:
    def canConstruct(self, ransomNote: str, magazine: str) -> bool:
        record = [0] * 26
        for i in magazine:
            record[ord(i) - ord('a')] += 1
        for i in ransomNote:
            record[ord(i) - ord('a')] -= 1
        for i in range(26):
            if record[i] < 0:
                return False
        return True

第15题. 三数之和

力扣题目链接(opens new window)

给你一个包含 n 个整数的数组 nums,判断 nums 中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?请你找出所有满足条件且不重复的三元组。

注意: 答案中不可以包含重复的三元组。

示例:

给定数组 nums = [-1, 0, 1, 2, -1, -4],

满足要求的三元组集合为: [ [-1, 0, 1], [-1, -1, 2] ]

先写个暴力搜索所有结果的版本来寻找思路:

class Solution:
    def threeSum(self, nums: List[int]) -> List[List[int]]:
        l = len(nums)
        result = []
        hist = []
        for i in range(l):
            for j in range(i+1,l):
                for k in range(j+1,l):
                    if nums[i] + nums[j] + nums[k] == 0:
                        if set([nums[i],nums[j],nums[k]]) not in hist:
                            hist.append(set([nums[i],nums[j],nums[k]]))
                            result.append([nums[i],nums[j],nums[k]])
        return result

这种时间复杂度肯定是过不了测试的,没法通过倒数第5个算例,含有大量五位数字的算例。

尝试双指针,去重做的很烂,差一点过不了测试(再多10ms就不行了),

class Solution:
    def threeSum(self, nums: List[int]) -> List[List[int]]:
        result = []
        hist = []
        l = len(nums)
        nums.sort()
        for i in range(l - 2):
            right = l - 1
            left = i + 1
            while right > left:
                res = nums[i] + nums[left] + nums[right]
                if res < 0:
                    left += 1
                elif res > 0:
                    right -= 1 
                else:
                    if set([nums[i],nums[left],nums[right]]) not in hist:
                        hist.append(set([nums[i],nums[left],nums[right]]))
                        result.append([nums[i],nums[left],nums[right]])
                    left += 1
        return result

继续改进,跳过相邻且相等的值十分重要。如下:

class Solution:
    def threeSum(self, nums: List[int]) -> List[List[int]]:
        result = []
        hist = []
        l = len(nums)
        nums.sort()
        for i in range(l - 2):
            if i > 0 and nums[i] == nums[i - 1]:
                continue
            else:
                right = l - 1
                left = i + 1
                while right > left:
                    res = nums[i] + nums[left] + nums[right]
                    if res < 0:
                        left += 1
                    elif res > 0:
                        right -= 1 
                    else:
                        result.append([nums[i],nums[left],nums[right]])

                    
                    # 跳过相同的元素以避免重复
                        while right > left and nums[right] == nums[right - 1]:
                            right -= 1
                        while right > left and nums[left] == nums[left + 1]:
                            left += 1
                        left +=1
        return result

第18题. 四数之和

力扣题目链接(opens new window)

题意:给定一个包含 n 个整数的数组 nums 和一个目标值 target,判断 nums 中是否存在四个元素 a,b,c 和 d ,使得 a + b + c + d 的值与 target 相等?找出所有满足条件且不重复的四元组。

注意:

答案中不可以包含重复的四元组。

示例: 给定数组 nums = [1, 0, -1, 0, -2, 2],和 target = 0。 满足要求的四元组集合为: [ [-1, 0, 0, 1], [-2, -1, 1, 2], [-2, 0, 0, 2] ]

在前一题的基础上加套一层for循环,指针思路和去重思路完全一致,不多做解释。

class Solution:
    def fourSum(self, nums: List[int], target: int) -> List[List[int]]:
        l = len(nums)
        nums.sort()
        result = []
        for i in range(l-3):
            if i > 0 and nums[i] == nums[i-1]:
                continue
            for j in range(i+1,l-2):
                if j > i + 1 and nums[j] == nums[j-1]:
                    continue
                right = l - 1
                left = j + 1
                while left < right:
                    res = nums[i] + nums[j] + nums[left] + nums[right]
                    if res > target:
                        right -= 1
                    elif res < target:
                        left += 1
                    else:
                        result.append([nums[i],nums[j],nums[left],nums[right]])
                        while left < right and nums[left] == nums[left+1]:
                            left += 1
                        while left < right and nums[right] == nums[right-1]:
                            right -= 1
                        left += 1
                        right -= 1
        return result

你可能感兴趣的:(散列表,python,数据结构)